diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
index ee02ec8eb..7ec5f4dd8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
@@ -4,11 +4,14 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.Chunk;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public final class TilePos {
+public final class TilePos
+implements Pos3i<TilePos> {
     public int x;
     public int y;
     public int z;
@@ -39,36 +42,41 @@ public final class TilePos {
         this(entity.x, entity.y, entity.z);
     }
 
-    public @NotNull ChunkPos toChunkPos() {
-        return new ChunkPos(this);
-    }
-
-    public @NotNull ChunkTilePos toChunkTilePos() {
-        return new ChunkTilePos(this);
+    @Override
+    public int x() {
+        return this.x;
     }
 
-    public @NotNull TilePos add(final int x, final int y, final int z) {
-        return new TilePos(this.x + x, this.y + y, this.z + z);
+    @Override
+    public int y() {
+        return this.y;
     }
 
-    public @NotNull TilePos add(final @NotNull TilePos other) {
-        return new TilePos(this.x + other.x, this.y + other.y, this.z + other.z);
+    @Override
+    public int z() {
+        return this.z;
     }
 
-    public @NotNull TilePos add(final @NotNull Direction direction, final int distance) {
-        return new TilePos(this.x + direction.getOffsetX() * distance, this.y + direction.getOffsetY() * distance, this.z + direction.getOffsetZ() * distance);
+    public @NotNull TilePos add(final int x, final int y, final int z) {
+        return new TilePos(this.x + x, this.y + y, this.z + z);
     }
 
-    public @NotNull TilePos add(final @NotNull Direction direction) {
-        return this.add(direction, 1);
+    public @NotNull ChunkPos toChunkPos() {
+        return new ChunkPos(this);
     }
 
-    public @NotNull TilePos sub(final int x, final int y, final int z) {
-        return new TilePos(this.x - x, this.y - y, this.z - z);
+    public @NotNull ChunkTilePos toChunkTilePos() {
+        return new ChunkTilePos(this);
     }
 
-    public @NotNull TilePos sub(final @NotNull TilePos other) {
-        return new TilePos(this.x - other.x, this.y - other.y, this.z - other.z);
+    public boolean inBounds(final @NotNull WorldSource source) {
+        return
+            this.x >= World.MIN_BLOCK_X &&
+                this.y >= 0 &&
+                this.z >= World.MIN_BLOCK_Z &&
+                this.x <= World.MAX_BLOCK_X &&
+                this.y < source.getHeightBlocks() &&
+                this.z <= World.MAX_BLOCK_Z;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
index b35de9227..ce6d5835d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
@@ -106,7 +106,7 @@ public abstract class Weather {
                 int blockId = chunk.getBlockID(x, y, z);
                 int blockIdBelow = chunk.getBlockID(x, y - 1, z);
 
-                if (world.getBlockBiome(chunk.xPosition * 16 + x, y, chunk.zPosition * 16 + z).hasSurfaceSnow()) {
+                if (world.getBlockBiome(chunk.pos.x * 16 + x, y, chunk.pos.z * 16 + z).hasSurfaceSnow()) {
                     if (blockId == Blocks.LAYER_SNOW.id()) {
                         chunk.setBlockMetadata(x, y, z, 0);
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
index 6db888133..3f44abb55 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
@@ -43,10 +43,10 @@ public class WeatherSnow
     public void doChunkLoadEffect(@NotNull World world, @NotNull Chunk chunk) {
         if (world.weatherManager.getWeatherPower() <= 0.6f) return;
         for (int x = 0; x < 16; x++) {
-            int worldX = chunk.xPosition * 16 + x;
+            int worldX = chunk.pos.x * 16 + x;
             zLoop:
             for (int z = 0; z < 16; z++) {
-                int worldZ = chunk.zPosition * 16 + z;
+                int worldZ = chunk.pos.z * 16 + z;
                 int y = world.findTopSolidBlock(worldX, worldZ);
 
                 Biome biome = world.getBlockBiome(worldX, y, worldZ);
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 063497fa0..db87dc28b 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -15,10 +15,12 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.packet.*;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.server.world.chunk.provider.ChunkProviderServer;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.server.MinecraftServer;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldServer extends World
 {
@@ -55,11 +57,10 @@ public class WorldServer extends World
     }
 
     @Override
-    public boolean canMineBlock(final Player player, final int x, final int y, final int z)
-    {
-        if (this.mcServer.spawnProtectionRange <= 0 || this.mcServer.playerList.isOp(player.uuid)) return super.canMineBlock(player, x, y, z);
-        final int dx = (int)MathHelper.abs(x - this.levelData.getSpawnX());
-        final int dz = (int)MathHelper.abs(z - this.levelData.getSpawnZ());
+    public boolean canMineBlock(final @NotNull Player player, final @NotNull TilePos tilePos) {
+        if (this.mcServer.spawnProtectionRange <= 0 || this.mcServer.playerList.isOp(player.uuid)) return super.canMineBlock(player, tilePos);
+        final int dx = (int)MathHelper.abs(tilePos.x - this.levelData.getSpawnX());
+        final int dz = (int)MathHelper.abs(tilePos.z - this.levelData.getSpawnZ());
         return Math.max(dx, dz) > this.mcServer.spawnProtectionRange;
     }
 
@@ -200,11 +201,11 @@ public class WorldServer extends World
         mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new PacketExplosion(x, y, z, explosionSize, explosion.destroyedBlockPositions, isCannonBall));
         return explosion;
     }
+
     @Override
-    public void triggerEvent(int x, int y, int z, int index, int data)
-    {
-        super.triggerEvent(x, y, z, index, data);
-        mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new PacketBlockEvent(x, y, z, index, data));
+    public void triggerEvent(final @NotNull TilePos tilePos, final int index, final int data) {
+        super.triggerEvent(tilePos, index, data);
+        mcServer.playerList.sendPacketToPlayersAroundPoint(tilePos.x, tilePos.y, tilePos.z, 64.0, dimension.id, new PacketBlockEvent(tilePos.x, tilePos.y, tilePos.z, index, data));
     }
 
     public void checkLock()
diff --git a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
index f32caa13c..516d5c72b 100644
--- a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
@@ -201,7 +201,7 @@ public class ChunkProviderServer
         }
         catch (IOException ioexception)
         {
-            LOGGER.error("Failed to save chunk at X:{}, Z:{} to disk!", chunk.xPosition, chunk.zPosition, ioexception);
+            LOGGER.error("Failed to save chunk at X:{}, Z:{} to disk!", chunk.pos.x, chunk.pos.z, ioexception);
         }
     }
 
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
index 519993199..5302ec8d9 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAComplexChunk.java
@@ -22,7 +22,7 @@ public class BTAComplexChunk implements ViewerChunk {
     public ViewerBiome getBiome(ChunkPos3D pos) {
         net.minecraft.core.world.biome.Biome b = chunk.getBlockBiome(pos.x, pos.y, pos.z);
         if (b != null) return new BTABiome(b);;
-        return new BTABiome(provider.getBiome(chunk.xPosition * ViewerChunk.CHUNK_SIZE_X + pos.x, pos.y, chunk.zPosition * ViewerChunk.CHUNK_SIZE_Z + pos.z));
+        return new BTABiome(provider.getBiome(chunk.pos.x * ViewerChunk.CHUNK_SIZE_X + pos.x, pos.y, chunk.pos.z * ViewerChunk.CHUNK_SIZE_Z + pos.z));
     }
 
     @Override
